Debian Bug report logs - #620958
dpkg outputs tons of new warning messages with no obvious way to fix them

version graph

Package: dpkg; Maintainer for dpkg is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg is src:dpkg.

Reported by: Sven-Haegar Koch <haegar@sdinet.de>

Date: Tue, 5 Apr 2011 12:30:01 UTC

Severity: normal

Found in versions dpkg/1.16.1.2, dpkg/1.16.0.1, dpkg/1.16.0.3

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Tue, 05 Apr 2011 12:30:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven-Haegar Koch <haegar@sdinet.de>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 05 Apr 2011 12:30:10 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Sven-Haegar Koch <haegar@sdinet.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Tue, 05 Apr 2011 14:14:57 +0200
Package: dpkg
Version: 1.16.0.1
Severity: normal


Since the 1.16.0 update dpkg outputs a ton of new warning messages for each
run (multiple times for one apt-get dist-upgrade).

Example:

aurora:~# dpkg -l
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 301 package 'libmimelib1':
 missing architecture
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 317 package 'libgal19':
 missing architecture
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 1120 package 'gimp1.2':
 missing architecture
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 2659 package 'mesag3+ggi':
 missing architecture
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 3515 package 'libmagick5.5.7':
 missing architecture
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 3537 package 'libmagick5.5.4':
 missing architecture
...
(all together around 600 more lines of output)

These seem all to only affect packages long removed, but not purged.

This system has been installed years ago using something pre-woody, and
since then keept uptoday with unstable, and moved from one physical machine
to the next without a reinstall.



When
aurora:~# dpkg -i ...something.deb
...the same "missing architecture" warnings as above, in addition:
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 33441 package 'am-utils':
 'Replaces' field, reference to 'amd': error in version: version number does not start with digit
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 33444 package 'am-utils':
 'Conflicts' field, reference to 'amd': error in version: version number does not start with digit
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 99587 package 'wmnetselect':
 'Suggests' field, reference to 'mozilla': error in version: version number does not start with digit
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 115332 package 'tac-plus':
 error in Version string 'F4.0.4.alpha-10': version number does not start with digit
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 189000 package 'epic4-script-thirdeye':
 'Depends' field, reference to 'epic4': error in version: version number does not start with digit
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 223197 package 'cnews':
 error in Version string 'cr.g7-31': version number does not start with digit
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 282794 package 'request-tracker1':
 'Conflicts' field, reference to 'rt': error in version: version number does not start with digit
dpkg: warning: parsing file '/var/lib/dpkg/available' near line 300193 package 'epic4':
 'Conflicts' field, reference to 'epic4-help': error in version: version number does not start with digit
(Reading database ... 284590 files and directories currently installed.)



-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable'), (101, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 2.6.38-sdinet2-aurora (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages dpkg depends on:
ii  coreutils               8.5-1            GNU core utilities
ii  libbz2-1.0              1.0.5-6          high-quality block-sorting file co
ii  libc6                   2.11.2-11        Embedded GNU C Library: Shared lib
ii  libselinux1             2.0.98-1         SELinux runtime shared libraries
ii  xz-utils                5.0.0-2          XZ-format compression utilities
ii  zlib1g                  1:1.2.3.4.dfsg-3 compression library - runtime

dpkg recommends no packages.

Versions of packages dpkg suggests:
ii  apt                           0.8.13.1   Advanced front-end for dpkg

-- debconf-show failed




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Tue, 05 Apr 2011 13:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 05 Apr 2011 13:09:03 GMT) Full text and rfc822 format available.

Message #10 received at 620958@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Sven-Haegar Koch <haegar@sdinet.de>, 620958@bugs.debian.org
Subject: Re: Bug#620958: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Tue, 5 Apr 2011 14:57:15 +0200
Hello,

On Tue, 05 Apr 2011, Sven-Haegar Koch wrote:
> aurora:~# dpkg -l
> dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 301 package 'libmimelib1':
>  missing architecture
[...]
> These seem all to only affect packages long removed, but not purged.

Can you show us the entry in the status file for one of those packages?

Packages which are in status "config-files" (i.e. removed but not purged)
should have all their status information including the Architecture field.

> dpkg: warning: parsing file '/var/lib/dpkg/available' near line 33441 package 'am-utils':
>  'Replaces' field, reference to 'amd': error in version: version number does not start with digit

Clean up the cruft in the available file by running "dpkg --clear-avail"
and you'll get rid of those.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Tue, 05 Apr 2011 13:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven-Haegar Koch <haegar@sdinet.de>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 05 Apr 2011 13:36:03 GMT) Full text and rfc822 format available.

Message #15 received at 620958@bugs.debian.org (full text, mbox):

From: Sven-Haegar Koch <haegar@sdinet.de>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 620958@bugs.debian.org
Subject: Re: Bug#620958: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Tue, 5 Apr 2011 15:29:11 +0200 (CEST)
On Tue, 5 Apr 2011, Raphael Hertzog wrote:

> Hello,
> 
> On Tue, 05 Apr 2011, Sven-Haegar Koch wrote:
> > aurora:~# dpkg -l
> > dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 301 package 'libmimelib1':
> >  missing architecture
> [...]
> > These seem all to only affect packages long removed, but not purged.
> 
> Can you show us the entry in the status file for one of those packages?
> 
> Packages which are in status "config-files" (i.e. removed but not purged)
> should have all their status information including the Architecture field.

Two examples:

Package: libmimelib1
Status: deinstall ok config-files
Priority: optional
Section: libs
Installed-Size: 264
Maintainer: Christopher L Cheney <ccheney@debian.org>
Source: kdenetwork
Version: 4:3.1.4-1
Config-Version: 4:3.1.4-1
Provides: libmimelib
Depends: libc6 (>= 2.3.2-1), libgcc1 (>= 1:3.3.1-1), libstdc++5 (>= 1:3.3.1-1)
Conflicts: libmimelib
Description: KDE network mime library
 KDE is a powerful Open Source graphical desktop environment
 for Unix workstations. It combines ease of use, contemporary
 functionality, and outstanding graphical design with the
 technological superiority of the Unix operating system.
 .
 This library is used by several KDE applications to handle mime types.
 .
 This package is part of the official KDE network module.

Package: epic4
Status: deinstall ok config-files
Priority: optional
Section: net
Installed-Size: 944
Maintainer: Joseph Carter <knghtbrd@debian.org>
Version: 1:1.0.1-1
Config-Version: 1:1.0.1-1
Provides: irc
Depends: libc6 (>= 2.2.2-2), libncurses5 (>= 5.2.20010310-1), epic4-help
Suggests: epic4-script
Conflicts: epic4-dbg
Conffiles:
 /etc/epic4/epic4.irc 1671c2de63dcddc761ff2e3cc8ade8cb
 /etc/epic4/servers 90e770be749c418b27a2a1ba19536f71
 /etc/epic4/epic4.irc 8ef1b800ab08b734e025cd81aa25df6a
 /etc/epic4/servers 90e770be749c418b27a2a1ba19536f71
Description: epic irc client, version 4
 epic4 is an irc client based on ircII.  It is primarily suited to users who
 wish to write their own irc scripts or have irc scripts written by others.
 .
 Previous versions of epic were 100% compatible with ircII 2.8.2, though
 this is no longer the case.  Instead we've taken a new direction and chosen
 to find places where compatibility with ircII is undesirable and fix them.
 No gratuitous incompatibilities have been added, though many new features
 have been.

> > dpkg: warning: parsing file '/var/lib/dpkg/available' near line 33441 package 'am-utils':
> >  'Replaces' field, reference to 'amd': error in version: version number does not start with digit
> 
> Clean up the cruft in the available file by running "dpkg --clear-avail"
> and you'll get rid of those.

This helped, and removed all the problems with /var/lib/dpkg/available 
(but not with the /var/lib/dpkg/status warnings).

Thanks,

c'ya
sven-haegar

-- 
Three may keep a secret, if two of them are dead.
- Ben F.




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 06 Apr 2011 14:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 06 Apr 2011 14:27:12 GMT) Full text and rfc822 format available.

Message #20 received at 620958@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Sven-Haegar Koch <haegar@sdinet.de>, 620958@bugs.debian.org
Subject: Re: Bug#620958: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Wed, 6 Apr 2011 16:23:36 +0200
Hello,

On Tue, 05 Apr 2011, Sven-Haegar Koch wrote:
> Package: libmimelib1
> Status: deinstall ok config-files

I did some code archeology to try to find out an explanation of why dpkg
would have dropped that field. 

And I found it: http://bugs.debian.org/228253

It got "fixed" by this commit:

commit 2ef42b027e4267432a41343e28f102b1dae668d2
Author: Scott James Remnant <keybuk@debian.org>
Date:   Mon Mar 8 18:37:36 2004 +0000

Prior to this, the architecture field was not stored at all in the status
file (in fact it was explicitly dropped by the parsedb function).

The change is very old, not many users will be affected by this.

Guillem, what do you think? Should we silence the warning due to this?

Sven, in the mean time I suggest you do "aptitude purge ~c" to clean up
all those packages and you will get rid of those warnings (but you'll
loose the configuration files for those old uninstalled packages).

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 06 Apr 2011 18:15:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 06 Apr 2011 18:15:17 GMT) Full text and rfc822 format available.

Message #25 received at 620958@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: 620958@bugs.debian.org
Cc: Sven-Haegar Koch <haegar@sdinet.de>
Subject: Re: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Wed, 6 Apr 2011 13:10:53 -0500
Hi,

Raphael Hertzog wrote:

> The change is very old, not many users will be affected by this.
>
> Guillem, what do you think? Should we silence the warning due to this?

I am not Guillem :) but I think the ideal thing would be a way for the
user to (perhaps explicitly) update the status db by inserting an
architecture.  Available seems less of a problem given the workaround
"dpkg --clear-avail"; in an ideal world "apt-get update" and "dselect
update" would be taught[1] to remove stale entries, though.

Especially for the sake of cross-upgrade support, the architecture
field seems kind of important.

[1] http://bugs.debian.org/478970 and especially
http://bugs.debian.org/551638




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 06 Apr 2011 19:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 06 Apr 2011 19:18:03 GMT) Full text and rfc822 format available.

Message #30 received at 620958@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Jonathan Nieder <jrnieder@gmail.com>, 620958@bugs.debian.org
Cc: Sven-Haegar Koch <haegar@sdinet.de>
Subject: Re: Bug#620958: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Wed, 6 Apr 2011 21:15:35 +0200
On Wed, 06 Apr 2011, Jonathan Nieder wrote:
> I am not Guillem :) but I think the ideal thing would be a way for the
> user to (perhaps explicitly) update the status db by inserting an
> architecture.

Why ?

1/ It concerns packages which have not been touched since 2004 or packages
which were installed before 2004 and got removed but not purged since then
2/ We can't invent the value to put in Architecture

> Available seems less of a problem given the workaround
> "dpkg --clear-avail"; in an ideal world "apt-get update" and "dselect
> update" would be taught[1] to remove stale entries, though.

dselect update sometimes does depending on the "method" configured.

Right now, it serves no purpose for apt-get to update the available file.

> Especially for the sake of cross-upgrade support, the architecture
> field seems kind of important.

Which is why we're requiring it now and why we're more verbose.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 06 Apr 2011 19:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 06 Apr 2011 19:57:07 GMT) Full text and rfc822 format available.

Message #35 received at 620958@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: 620958@bugs.debian.org
Cc: Sven-Haegar Koch <haegar@sdinet.de>
Subject: Re: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Wed, 6 Apr 2011 14:56:14 -0500
Hi,

Raphael Hertzog wrote:

> 1/ It concerns packages which have not been touched since 2004 or packages
> which were installed before 2004 and got removed but not purged since then

I did say "ideally".  I can understand if you're not motivated to work
on it.

(That said, iiuc the above is not so rare of a usage pattern.  Some
people never purge packages until they have to, to save some trouble
reconfiguring when it is time to install again later.)

> 2/ We can't invent the value to put in Architecture

It seems likely this has been covered before, but just in case: why
not put in the native architecture for already-installed, ancient
packages?

If I am reading the multiarch spec correctly, i386 packages cannot
satisfy dependencies from amd64 packages without a "Multiarch" field,
and i386 packages are not co-installable with other packages of the
same name without a "Multiarch" field.  So although this would be
technically inaccurate (some of the ancient packages were presumably
Architecture: all), I think it should be safe.

> dselect update sometimes does depending on the "method" configured.
>
> Right now, it serves no purpose for apt-get to update the available file.

Actually I'm a bit puzzled by the behavior.  sync-available (from
dctrl-tools) and the apt method's "update" script call
"apt-cache dumpavail" to write a new available file and
"dpkg --update-avail" to use it, ignoring the old one.  So why are
people needing to run "dpkg --clear-avail"?

Would it be possible in the long term for dpkg to stop caring about
"available" altogether (leaving it to dselect)?

>> Especially for the sake of cross-upgrade support, the architecture
>> field seems kind of important.
>
> Which is why we're requiring it now and why we're more verbose.

Yes, and thanks for that.  Without a warning to point out these old
package records, it would be a lot harder to figure out what to do
about them.




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Thu, 07 Apr 2011 06:09:28 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 07 Apr 2011 06:09:34 GMT) Full text and rfc822 format available.

Message #40 received at 620958@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Jonathan Nieder <jrnieder@gmail.com>, 620958@bugs.debian.org
Cc: Sven-Haegar Koch <haegar@sdinet.de>
Subject: Re: Bug#620958: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Thu, 7 Apr 2011 08:04:58 +0200
On Wed, 06 Apr 2011, Jonathan Nieder wrote:
> > 2/ We can't invent the value to put in Architecture
> 
> It seems likely this has been covered before, but just in case: why
> not put in the native architecture for already-installed, ancient
> packages?

It could be Architecture: all instead of the native architecture. And
some packages might have been installed with --force-architecture.

> > dselect update sometimes does depending on the "method" configured.
> >
> > Right now, it serves no purpose for apt-get to update the available file.
> 
> Actually I'm a bit puzzled by the behavior.  sync-available (from
> dctrl-tools) and the apt method's "update" script call
> "apt-cache dumpavail" to write a new available file and
> "dpkg --update-avail" to use it, ignoring the old one.  So why are
> people needing to run "dpkg --clear-avail"?

Because people don't use dselect and the available file just keeps a log
of formerly installed packages in that case. And the "ftp" method of
dselect runs --clear-avail optionnaly and uses --merge-avail.

> Would it be possible in the long term for dpkg to stop caring about
> "available" altogether (leaving it to dselect)?

Yes, it's more or less the plan. We've just changed dpkg to not
parse/write it for most of the commands and I wanted to discuss with
guillem why he kept it for plain package install (archivefiles() still
passes the available flag to modstatdb_init).

See commits fb49e131ef32039277c538f759ab19c1ff22e8fd,
9c01b373009ac462afbdb9375abd2c7b9abc19d5.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Sat, 09 Apr 2011 08:21:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 09 Apr 2011 08:21:16 GMT) Full text and rfc822 format available.

Message #45 received at 620958@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Raphael Hertzog <hertzog@debian.org>, 620958@bugs.debian.org
Cc: Jonathan Nieder <jrnieder@gmail.com>
Subject: Re: Bug#620958: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Sat, 9 Apr 2011 10:12:52 +0200
Hi!

On Thu, 2011-04-07 at 08:04:58 +0200, Raphael Hertzog wrote:
> On Wed, 06 Apr 2011, Jonathan Nieder wrote:
> > Would it be possible in the long term for dpkg to stop caring about
> > "available" altogether (leaving it to dselect)?
> 
> Yes, it's more or less the plan. We've just changed dpkg to not
> parse/write it for most of the commands and I wanted to discuss with
> guillem why he kept it for plain package install (archivefiles() still
> passes the available flag to modstatdb_init).
> 
> See commits fb49e131ef32039277c538f759ab19c1ff22e8fd,
> 9c01b373009ac462afbdb9375abd2c7b9abc19d5.

The changes I introduced were intended to not change current
behaviour, that's why they still parse the available file in some
cases. That's the case for several query commands, for install it's
because it has always recorded the newly installed package in the
available file too.

The possibility to stop doing that is still pending a discussion with
the frontend developers, which I have queued with several others for
after I've cleared up some pending things first.

thanks,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Sat, 16 Apr 2011 16:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "D. Kelly" <user.kernel@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 16 Apr 2011 16:12:03 GMT) Full text and rfc822 format available.

Message #50 received at 620958@bugs.debian.org (full text, mbox):

From: "D. Kelly" <user.kernel@gmail.com>
To: 620958@bugs.debian.org
Date: Sat, 16 Apr 2011 09:09:43 -0700
You can include me in the number of users who is now being spammed by
all the warnings.  I managed to get rid of quite a few of them with
"dpkg --clear-avail"
 but I still get all the status ones.  For example:

dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 705
package 'linux-image-2.6.38.2.amd64-x2.20110328.1':
 error in Version string 'Build.1': version number does not start with digit
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line
12717 package 'linux-image-2.6.38.1.amd64-x2.20110323.1':
 error in Version string 'Build.1': version number does not start with digit
dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line
21937 package 'linux-image-2.6.38.3.amd64-x2.20110414.1':
 error in Version string 'Build.1': version number does not start with digit

Thanks for addressing this.  The problem is very annoying to say the least.




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 04 May 2011 07:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Peter Gervai <grin@grin.hu>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 04 May 2011 07:42:04 GMT) Full text and rfc822 format available.

Message #55 received at 620958@bugs.debian.org (full text, mbox):

From: Peter Gervai <grin@grin.hu>
To: 620958@bugs.debian.org
Subject: <AOL>me too!</AOL>
Date: Wed, 4 May 2011 09:28:12 +0200
Found: 1.16.0.2

What about --list-stale-entries and --purge-stale-entries ? :) [or
just the latter with the compulsory "are you sure man?"]

g




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Tue, 17 May 2011 11:16:34 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 17 May 2011 11:16:40 GMT) Full text and rfc822 format available.

Message #60 received at 620958@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: 620958@bugs.debian.org
Subject: Re: your mail
Date: Tue, 17 May 2011 13:14:25 +0200
found 620958 1.16.0.3
thanks

On 2011-04-16 09:09:43 -0700, D. Kelly wrote:
> You can include me in the number of users who is now being spammed by
> all the warnings.  I managed to get rid of quite a few of them with
> "dpkg --clear-avail"
>  but I still get all the status ones.  For example:

Me too (for my old PowerBook).

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Bug Marked as found in versions dpkg/1.16.0.3. Request was from Vincent Lefevre <vincent@vinc17.net> to control@bugs.debian.org. (Tue, 17 May 2011 11:16:48 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 18 May 2011 03:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to David Hill <reportbugs@binarystorm.net>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 18 May 2011 03:57:03 GMT) Full text and rfc822 format available.

Message #67 received at 620958@bugs.debian.org (full text, mbox):

From: David Hill <reportbugs@binarystorm.net>
To: 620958@bugs.debian.org
Subject: I have the same issue...
Date: Tue, 17 May 2011 23:50:50 -0400
I manually edited /var/lib/dpkg/status to add architecture to the packages where it was missing.  Everything's working fine now! :)

Thank you for the bug report!
-- 
This message has been scanned for viruses and
dangerous content by MailScanner, and is
believed to be clean.





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 18 May 2011 04:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to reportbugs@binarystorm.net:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 18 May 2011 04:36:03 GMT) Full text and rfc822 format available.

Message #72 received at 620958@bugs.debian.org (full text, mbox):

From: reportbugs@binarystorm.net
Subject: Bug 620958
Date: Tue, 17 May 2011 23:29:56 -0400
I fixed the problem by manually editing /var/lib/dpkg/status and adding the architecture field... 

Thanks for the bug reports ... it was very annoying! :)

At some point, my HDD got full and I tought it was simply corrupted but it wasn't!



-- 
This message has been scanned for viruses and
dangerous content by MailScanner, and is
believed to be clean.





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Fri, 03 Jun 2011 07:42:50 GMT) Full text and rfc822 format available.

Acknowledgement sent to Fredrik Hallenberg <megahallon@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 03 Jun 2011 07:42:50 GMT) Full text and rfc822 format available.

Message #77 received at 620958@bugs.debian.org (full text, mbox):

From: Fredrik Hallenberg <megahallon@gmail.com>
To: 620958@bugs.debian.org
Subject: Bug 620958
Date: Fri, 3 Jun 2011 09:40:50 +0200
[Message part 1 (text/plain, inline)]
Hi I just purged over 2000 old packages, about 600 of them generated the
"missing arch" warning for every dpkg run which was annoying to say the
least.
Obviously it was not an alternative to do the cleaning manually.

I also found 5 packages which were properly installed but also generated
warnings. Yes, they have been installed since before 2004 and have not been
changed after that. I had to reinstall them.

It looks to me as this warning is not really valid, I got it on only because
my install is old. That said, it was probably good that it forced me to
clean out all that crap.

Thanks
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Mon, 20 Jun 2011 18:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Luis <lluislz@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 20 Jun 2011 18:21:03 GMT) Full text and rfc822 format available.

Message #82 received at 620958@bugs.debian.org (full text, mbox):

From: Luis <lluislz@gmail.com>
To: 620958@bugs.debian.org
Subject: a dirty fix
Date: Mon, 20 Jun 2011 20:18:56 +0200
[Message part 1 (text/plain, inline)]
Just created a fast dirty fix:
- Copy the output warnings (all the "parsing file '/var/lib/dpkg/status'
near line XXX" lines) in a file named "/tmp/warnings"
- Copy the code below in a file named "repair_status.rb"
- In the code replace "Architecture: i386" for your architecture line
- Run "ruby repair_status.rb".

 It will create a /tmp/output file that you can use as a new
"/var/lib/dpkg/status" (backup it first). The "Architecture: i386" line (or
the one you replaced) will be added above the first "Maintaner:" line found
before the line warning


def find_line(lines, line_number)
    1.upto(100) do |i|
        line = lines[line_number-i]
        return -1 if !line || line.strip.length==0
        return line_number-i-1 if line.start_with?("Maintainer:")
    end
    return -1
end

warnings = File.read("/tmp/warnings").split("\n")
lines = File.read("/var/lib/dpkg/status").split("\n")
lines << ""
warnings.map{|line| (line =~ /parsing file '\/var\/lib\/dpkg\/status' near
line (\d+)/) ? $1.to_i : nil}.compact.reverse .each do |line_number|
    line = find_line(lines, line_number)
    if (line>0)
        lines.insert(line, "Architecture: i386")
        puts "inserting architecure in line #{line}, missing from
#{line_number}"
    else
        puts "not fixed for #{line_number}"
    end
end

File.open("/tmp/output", "w+") {|f| f.write(lines.join("\n"))}
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Thu, 07 Jul 2011 09:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Kingsley G. Morse Jr." <kingsley@loaner.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 07 Jul 2011 09:30:06 GMT) Full text and rfc822 format available.

Message #87 received at 620958@bugs.debian.org (full text, mbox):

From: "Kingsley G. Morse Jr." <kingsley@loaner.com>
To: 620958@bugs.debian.org
Subject: Add all missing Architecture: lines?
Date: Thu, 7 Jul 2011 02:09:12 -0700
dpkg has been an enormous time saver for me over
the years.

Thank you very much for maintaining it.

Unfortunately, I ran into this bug too.

At least for me, the above ruby script only fixed
a small fraction of /var/lib/dpkg/status.

I'm considering various fixes.

Would it be OK if every entry in
/var/lib/dpkg/status ended up having an
"Architecture: " line?

Thanks,
Kingsley





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Thu, 07 Jul 2011 09:42:17 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Kingsley G. Morse Jr." <kingsley@loaner.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 07 Jul 2011 09:42:21 GMT) Full text and rfc822 format available.

Message #92 received at 620958@bugs.debian.org (full text, mbox):

From: "Kingsley G. Morse Jr." <kingsley@loaner.com>
To: 620958@bugs.debian.org
Subject: Add Architecture: "all" or (in my case) "i386"?
Date: Thu, 7 Jul 2011 02:41:08 -0700
If it's OK for every entry in /var/lib/dpkg/status
to end up having an "Architecture: " line, then
how would one know whether to specify an
architecture of 

    "all" 
    
or (in my case) 

    "i386"?

Thanks,
Kingsley





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Thu, 07 Jul 2011 12:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 07 Jul 2011 12:48:10 GMT) Full text and rfc822 format available.

Message #97 received at 620958@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: "Kingsley G. Morse Jr." <kingsley@loaner.com>, 620958@bugs.debian.org
Subject: Re: Bug#620958: Add Architecture: "all" or (in my case) "i386"?
Date: Thu, 7 Jul 2011 14:08:27 +0200
On Thu, 07 Jul 2011, Kingsley G. Morse Jr. wrote:
> If it's OK for every entry in /var/lib/dpkg/status
> to end up having an "Architecture: " line, then
> how would one know whether to specify an
> architecture of 
> 
>     "all" 
>     
> or (in my case) 
> 
>     "i386"?

The easiest solution for now is to purge the packages in config-files
status.

sudo aptitude purge ~c

Make sure you don't need to keep the configuration of the affected
packages though. And for the other affected packages you should just
reinstall them.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Thu, 07 Jul 2011 17:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 07 Jul 2011 17:03:05 GMT) Full text and rfc822 format available.

Message #102 received at 620958@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 620958@bugs.debian.org, "Kingsley G. Morse Jr." <kingsley@loaner.com>
Subject: Re: Add Architecture: "all" or (in my case) "i386"?
Date: Thu, 7 Jul 2011 12:01:13 -0500
Hi,

Raphael Hertzog wrote:

> The easiest solution for now is to purge the packages in config-files
> status.
>
> sudo aptitude purge ~c
>
> Make sure you don't need to keep the configuration of the affected
> packages though. And for the other affected packages you should just
> reinstall them.

Thanks for this advice; maybe it would be useful to put it in a NEWS
file to help people upgrading.  Minor nitpick: I believe "solution"
means "workaround" above (a solution would involve dpkg automatically
or by request filling in the architecture fields with a safe default,
like always putting in the native architecture --- yes, this would be
technically inaccurate if the package had been installed with
--force-architecture or was an arch-all package, but I don't see how
it would cause any problems).




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Sat, 09 Jul 2011 21:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Kingsley G. Morse Jr." <kingsley@loaner.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 09 Jul 2011 21:33:03 GMT) Full text and rfc822 format available.

Message #107 received at 620958@bugs.debian.org (full text, mbox):

From: "Kingsley G. Morse Jr." <kingsley@loaner.com>
To: 620958@bugs.debian.org
Subject: What if?
Date: Sat, 9 Jul 2011 14:28:20 -0700
In the interest of considering all possibilities,
it seems to me that it might also be possible to

    a.) make issuing these warnings configurable, or 

    b.) back them out altogether.

Thanks,
Kingsley





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Thu, 21 Jul 2011 15:00:17 GMT) Full text and rfc822 format available.

Acknowledgement sent to Greg Alexander <grenuh@galexander.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 21 Jul 2011 15:00:17 GMT) Full text and rfc822 format available.

Message #112 received at 620958@bugs.debian.org (full text, mbox):

From: Greg Alexander <grenuh@galexander.org>
To: 620958@bugs.debian.org
Subject: A few notes about this problem
Date: Thu, 21 Jul 2011 10:50:35 -0400
Hi -

I use Debian specifically because it upgrades cleanly from antiquity.
I've never reinstalled Debian from scratch except when buying all-new
hardware, and usually not even then.  I had a computer from Debian
0.93rc6 to woody, and several others from woody to present day.

So this problem affects several of my computers. :)

First, thanks for dpkg --clear-avail!

The characterization is not quite complete.  I get warnings on packages
which are installed, as well as ones which are removed:

   dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 36776 package 'libdb2':
    missing architecture

From status:

   Package: libdb2
   Status: install ok installed
   Priority: required
   Section: base
   ...

Another note..."aptitude purge ~c" nearly destroyed my system.  I think a
long-removed package referenced a /etc/init.d file that had since been
replaced by a currently-installed package.  It was a very important
package (mysql-server on my web host).  But I got lucky and re-installing
the current package completely resolved it.  Just a caveat for other
people with cobbled systems.

However, it is only a warning, so I don't mind ignoring it so long as
apt/dpkg continue to ignore it.

So the moral of the story is that if you have this problem, dpkg
--clear-avail is a winner.  But "aptitude purge ~c" will not necessarily
fix the problem and may have a side-effect of breaking your system.

I'm just cut-and-pasting "Architecture: i386" all over
/var/lib/dpkg/status and having some success. :)

Thanks!
- Greg




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 03 Aug 2011 16:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marc MERLIN <marc_soft@merlins.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 03 Aug 2011 16:27:03 GMT) Full text and rfc822 format available.

Message #117 received at 620958@bugs.debian.org (full text, mbox):

From: Marc MERLIN <marc_soft@merlins.org>
To: 620958@bugs.debian.org
Cc: hertzog@debian.org
Subject: I had to downgrade to dpkg 1.15.5.6
Date: Wed, 3 Aug 2011 08:46:40 -0700
Raphael,

No offense, but I went through the entire bug, tried the ruby script
which did not work reliably (added duplicate architecture lines and
forgot some), and then I spent >1h trying to fix the file by hand, and
the more errors I fixed, the more dpkg --list would report more a few at
a time.

Back to dpkg 1.15.5.6 everything is happy.

I got hundreds of
dpkg: warning: parsing file '/var/lib/dpkg/status' near line 50983 package 'fortunes-min':
 missing architecture

So yes, I installed all my debian systems in the late 90's and they have
been upgraded every since then. This is why debian is great, and why I
keep using it.

dpkg was changed to assume that systems were installed more recently and
offers no fixup for old but then acceptable databases.
Note that clearing available does not fix anything since I have hundreds
of errors in the /var/lib/dpkg/status file.

My recommendation is that you provide a post-install that checks the
syntax of /var/lib/dpkg/status|available and fixes the files.

Until then, for the first time in 12 years, I'll be unable to further
upgrade my debian systems.

Thanks,
Marc
-- 
"A mouse is a device used to point at the xterm you want to type in" - A.S.R.
Microsoft is to operating systems ....
                                      .... what McDonalds is to gourmet cooking
Home page: http://marc.merlins.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Wed, 03 Aug 2011 17:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marc MERLIN <marc_soft@merlins.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 03 Aug 2011 17:57:03 GMT) Full text and rfc822 format available.

Message #122 received at 620958@bugs.debian.org (full text, mbox):

From: Marc MERLIN <marc_soft@merlins.org>
To: 620958@bugs.debian.org
Cc: hertzog@debian.org
Subject: Re: I had to downgrade to dpkg 1.15.5.6
Date: Wed, 3 Aug 2011 10:55:35 -0700
On Wed, Aug 03, 2011 at 08:46:40AM -0700, Marc MERLIN wrote:
> My recommendation is that you provide a post-install that checks the
> syntax of /var/lib/dpkg/status|available and fixes the files.

To make your life easier, I tared up my entire /var/lib/dpkg
if you want to see what an old DB looks like:
http://marc.merlins.org/tmp/dpkg-db.tar.gz (15MB)

Note that I also have packages which got called -gargamel1 by make-kpkg
which is indeed invalid too (kernel packages), but that's only a few of
them and maybe I can hand edit the databases to put -1gargamel1 instead
(or if your postinstall script could fix that too, that'd be awesome)

Thanks,
Marc
-- 
"A mouse is a device used to point at the xterm you want to type in" - A.S.R.
Microsoft is to operating systems ....
                                      .... what McDonalds is to gourmet cooking
Home page: http://marc.merlins.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Sat, 22 Oct 2011 02:15:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to agcosta@gis.net:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 22 Oct 2011 02:15:07 GMT) Full text and rfc822 format available.

Message #127 received at 620958@bugs.debian.org (full text, mbox):

From: "A. Costa" <agcosta@gis.net>
To: 620958@bugs.debian.org
Cc: Marc MERLIN <marc_soft@merlins.org>, Greg Alexander <grenuh@galexander.org>, "Kingsley G. Morse Jr." <kingsley@loaner.com>, Luis <lluislz@gmail.com>
Subject: Re: #620958 dpkg outputs tons of new warning messages (Kludge with 'sed')
Date: Fri, 21 Oct 2011 21:47:46 -0400
Hello 'dpkg' users,

Same problem here, because my Debian system has been going (upgraded
regularly) since the late '90s.  It turns out 'sed' can fix this, the
code is nigh unreadable but it works.

Anyway, from the command prompt (copy & paste should work):

	# the problem file
	I=/var/lib/dpkg/status

	# temp file to revise $I
	O=/tmp/status

	# get the most common Arch line (highest count) in status file
	A="`sed -n '/Architecture:/p' $I | \
	    sort | uniq -c | sort -g | \
	    sed -n '$s/^.*\(Arch.*\)/\1/p'`"

	# Learn to juggle with 'sed'.
	# 	How it works: Package descriptions are separated by blank lines.
	# 	Load the 'hold' buffer with consecutive lines, until there's a blank.
	#	If there's no Arch line, then look for a Maint, and put Arch after that.
	#	Empty 'hold' buffer and repeat several thousand times.
	sed -n '1{h;b};H;/./b;g;/\nArchitecture:/!{g;s/\(Maintainer:[^\n]*\n\)/\1'"$A"'\n/};p;n;h' $I > $O

	# verify the changes are good.
	diff -c $I $O | less

	# back up $I, just in case...
	bzip2 -9 < $I > ~/status_dpkg.bak.bz2

	# If the 'diff' looks OK, copy it over.  (as root)
	cp $O $I

HTH...




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Fri, 06 Jan 2012 19:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 06 Jan 2012 19:27:03 GMT) Full text and rfc822 format available.

Message #132 received at 620958@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Raphael Manfredi <Raphael_Manfredi@pobox.com>
Cc: 620958@bugs.debian.org
Subject: Re: Cannot configure dpkg-dev, complains about tar --warning
Date: Fri, 6 Jan 2012 13:11:51 -0600
found 620958 dpkg/1.16.1.2
quit

Hi Raphael,

Raphael Manfredi wrote:

> dpkg-query: warning: parsing file '/var/lib/dpkg/status' near line 1682 package 'sudo':
>  missing architecture
>
> What do I need to do to fix these warnings

Reinstalling "sudo" (and any other packages that have the missing
architecture field) might help.

This is <http://bugs.debian.org/620958>.  I recommend tolerating the
warnings for now, and occasionally reminding me to teach dpkg to add
in some made-up value for the missing architectures (or at least add a
NEWS.Debian with a standard procedure to get the architecture fields
filled in).

Hope that helps,
Jonathan




Bug Marked as found in versions dpkg/1.16.1.2. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Fri, 06 Jan 2012 19:27:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#620958; Package dpkg. (Fri, 06 Jan 2012 20:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 06 Jan 2012 20:15:03 GMT) Full text and rfc822 format available.

Message #139 received at 620958@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Raphael Manfredi <Raphael_Manfredi@pobox.com>
Cc: 620958@bugs.debian.org
Subject: Re: dpkg outputs tons of new warning messages with no obvious way to fix them
Date: Fri, 6 Jan 2012 14:12:51 -0600
Raphael Manfredi wrote:

> I wrote a little perl script to do the conversion.  God bless you for
> using a text file for the database and not some binary format:
>
> ---------------------------
> #!/usr/bin/perl
>
> use strict;
>
> my @lines;
> my $seen_arch = 0;
>
> while (<>) {
>	push (@lines, $_);
>	$seen_arch ||= /^Architecture:/;
>	if (/^$/) {
>		foreach my $line (@lines) { 
>			print $line;
>			if (!$seen_arch && $line =~ /^Maintainer:/) {
>				print "Architecture: i386\n";
>				$seen_arch = 1;
>			}
>		}
>		@lines = ();
>		$seen_arch = 0;
>	}
> }

Forwarding to the bug log.  Maybe some interested person could use
this to get started on writing some code for the post-installation
script to run on upgrade from older versions.




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 22:01:00 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.